/* Script  Data URI Encoder - by Eliastik */
$("#noscript").hide();
nbErrorJavascript = 0;
numImageSelectionOrdi = 0;
numHTMLEncode = 0;

function getDataUriImg(url, callback) {
    var extension = url.split('.').pop();
    var image = new Image();
    image.onload = function() {
        var canvas = document.createElement('canvas');
        canvas.width = this.naturalWidth;
        canvas.height = this.naturalHeight;
        canvas.getContext('2d').drawImage(this, 0, 0);
        try {
            callback(canvas.toDataURL('image/' + extension));
        } catch (err) {
            callback(canvas.toDataURL('image/png'));
        }
    };
    image.src = url;
}

function getDataUriTextHTML(text) {
    return "data:text/html;charset=utf8," + text;
}
$("#btnValider2").click(function() {
    startTime = new Date().getTime();
    elapsedTime = 0;
    var codeHTML = $("#codeHTML").val(); // on récupère le chemin entré
    $("#tmpTraitement2").text(""); // on vide le texte du temps de traitement
    if (codeHTML.trim() == "") { // si rien n'est entré
        $("#erreurForm2").show();
        $("#erreurForm2").html("<span class=\"icon icon-erreur\"></span> Vous n'avez rien entré. Veuillez réessayer.");
    } else { // si tout va bien
        $("#erreurForm2").hide();
        $("#erreurForm2").html("");
        numHTMLEncode++;
        var htmlEncoded = getDataUriTextHTML(codeHTML);
        var elAP = document.createElement("li");
        elAP.innerHTML = '<label class="resultsLabel"><a href="#" onclick="linkToUrl(codeHTMLEncodeNum' + numHTMLEncode + '.value);" title="Ouvrir le document dans un nouvel onglet">Document HTML n°' + numHTMLEncode + '</a></label><input type="text" id="codeHTMLEncodeNum' + numHTMLEncode + '" class="inputResults" value="" onFocus="select();" readonly="readonly" />';
        document.getElementById("resultsList").appendChild(elAP);
        $('#codeHTMLEncodeNum' + numHTMLEncode).val(htmlEncoded);
        var htmlEncoded = "";
        elapsedTime = new Date().getTime() - startTime;
        $("#tmpTraitement2").html("<span class=\"icon icon-duree\"></span> Durée du traitement : " + elapsedTime / 1000 + " seconde(s).");
    }
});
// Si l'élement CANVAS est indisponible, on bloque tout, sauf l'onglet "Texte HTML"
if (window.HTMLCanvasElement == null) {
    // on affiche un message d'erreur et on désactive les formulaires
    $("#canvasError").show();
    $("#cheminFile").attr("disabled", "disabled");
    $("#algorithme1").attr("disabled", "disabled");
    $("#btnValider1").attr("disabled", "disabled");
    $("#chemin").attr("disabled", "disabled");
    $("#algorithme").attr("disabled", "disabled");
    $("#btnValider").attr("disabled", "disabled");
    $("#contenu_onglet_dialogForm").css("color", "grey");
    $("#contenu_onglet_form").css("color", "grey");
} else {
    // appui bouton second formulaire
    $("#btnValider").click(function() {
        startTime = new Date().getTime();
        elapsedTime = 0;
        $("#erreurFormSecurite").hide();
        $("#erreurFormSecurite").html("");
        var cheminImg = $("#chemin").val(); // on récupère le chemin entré
        $("#tmpTraitement").text(""); // on vide le texte du temps de traitement
        if (cheminImg.trim() == "") { // si rien n'est entré
            $("#erreurForm").show();
            $("#erreurForm").html("<span class=\"icon icon-erreur\"></span> Vous n'avez entré aucun chemin d'image. Veuillez réessayer.");
        } else { // si tout va bien
            $("#erreurForm").hide();
            $("#erreurForm").html("");
            $("#erreurFormSecurite").show();
            $("#erreurFormSecurite").html('<span class="icon icon-erreur"></span> Il est possible qu\'une erreur soit survenue. Peut-être que votre navigateur n\'est pas compatible ou qu\'il ai désactivé l\'encodage pour des mesures de sécurité. Veuillez réessayer sur un autre navigateur. Il est également possible que l\'image soit introuvable. Dans ce cas, assurez-vous que le chemin de l\'image soit correct.');
            getDataUriImg(cheminImg, function(url) {
                if (url.trim() === '') {
                    $("#erreurFormSecurite").hide();
                    $("#erreurFormSecurite").html("");
                    $("#erreurForm").html("<span class=\"icon icon-erreur\"></span> 'L\'URL semble incorrecte...");
                } else {
                    $("#erreurFormSecurite").hide();
                    $("#erreurFormSecurite").html("");
                    var elAP = document.createElement("li");
                    elAP.textContent = cheminImg;
                    var texteFormatted = elAP.textContent;
                    elAP.innerHTML = '<label class="resultsLabel"><a href="' + texteFormatted + '" target="_blank" title="Ouvrir l\'image dans un nouvel onglet">' + texteFormatted + '</a></label><input type="text" class="inputResults" value="' + url + '" onFocus="select();" readonly="readonly" />';
                    document.getElementById("resultsList").appendChild(elAP);
                    elapsedTime = new Date().getTime() - startTime;
                    $("#tmpTraitement").html("<span class=\"icon icon-duree\"></span> Durée du traitement : " + elapsedTime / 1000 + " seconde(s).");
                }
            });
        }
    });

    // si l'API file n'est pas compatible
    if (typeof window.FileReader === 'undefined') {
        // on affiche un message d'erreur et on désactive le formulaire
        $("#erreurFileApi").show();
        $("#cheminFile").attr("disabled", "disabled");
        $("#algorithme1").attr("disabled", "disabled");
        $("#btnValider1").attr("disabled", "disabled");
        $("#contenu_onglet_dialogForm").css("color", "grey");
    } else {
        // si on clique sur le bouton du premier formulaire
        $("#btnValider1").click(function() {
            startTime = new Date().getTime();
            elapsedTime = 0;
            var fileInput = document.querySelector('#cheminFile'); // on donne le champ du choix de fichier
            var reader = new FileReader(); // on crée un nouvel objet pour lire le fichier
            reader.addEventListener('load', function() { // une fois le fichier chargé
                $("#tmpTraitementOne").text(""); // on vide le temps de traitement
                var cheminImg2 = reader.result; // on lit le fichier
                if (cheminImg2.trim() == "") { // non utilisé
                    $("#erreurFormOne").show();
                    $("#erreurFormOne").html("<span class=\"icon icon-erreur\"></span> Vous n'avez entré aucun chemin d'image. Veuillez réessayer.");
                } else { // si tout va bien
                    $("#erreurFormOne").hide();
                    $("#erreurFormOne").html("");
                    numImageSelectionOrdi++;
                    var elAP = document.createElement("li");
                    elAP.innerHTML = '<label class="resultsLabel"><a href="#" onclick="linkToUrl(imageSelectOrdi' + numImageSelectionOrdi + '.value);" title="Ouvrir l\'image dans un nouvel onglet">Image selectionnée sur l\'ordinateur n°' + numImageSelectionOrdi + '</a></label><input type="text" class="inputResults" id="imageSelectOrdi' + numImageSelectionOrdi + '" value="' + cheminImg2 + '" onFocus="select();" readonly="readonly" />';
                    var cheminImg2 = "";
                    document.getElementById("resultsList").appendChild(elAP);
                    elapsedTime = new Date().getTime() - startTime;
                    $("#tmpTraitementOne").html("<span class=\"icon icon-duree\"></span> Durée du traitement : " + elapsedTime / 1000 + " seconde(s).");
                }
            }, false);
            // on vérifie si un fichier a bien été choisi, et on le lit. Sinon, message d'erreur
            if (fileInput.files[0] != null) {
                reader.readAsDataURL(fileInput.files[0]);
            } else {
                $("#erreurFormOne").show();
                $("#erreurFormOne").html("<span class=\"icon icon-erreur\"></span> Vous n'avez sélectionné aucune image. Veuillez réessayer.");
            }
        });
    }
}
/* autre */
// fermeture de l'information sur les fichiers PNG
$("#close").click(function() {
    $("#infosPng").fadeOut(250);
});
$("#closeMagic").click(function() {
    $("#infosMagic").fadeOut(250);
});
// lors du scroll, l'header devient transparent
$(window).scroll(function() {
    if ($(this).scrollTop() > 1) {
        $('#header').addClass("headerTransparent");
    } else {
        $('#header').removeClass("headerTransparent");
    }
});
// ...
var kona = [38, 38, 40, 40, 37, 39, 37, 39, 66, 65],
    nbk = 0;
$(document).keydown(function(e) {
    if (e.keyCode === kona[nbk++]) {
        if (nbk === kona.length) {
            $("#iconeApp").css("background-image", "url(images/pacman.gif)");
            $("#iconeApp").attr("title", "Pac-man ! (retour à l'accueil)");
            $("#infosMagic").show();
            nbk = 0;
            return false;
        }
    } else {
        nbk = 0;
    }
});
// les onglets et la fonction
function change_onglet(name) {
    document.getElementById('onglet_' + anc_onglet).className = 'onglet_0 onglet';
    document.getElementById('onglet_' + name).className = 'onglet_1 onglet';
    document.getElementById('contenu_onglet_' + anc_onglet).style.display = 'none';
    document.getElementById('contenu_onglet_' + name).style.display = 'block';
    anc_onglet = name;
}
var anc_onglet = 'dialogForm';
change_onglet(anc_onglet);
// permet aux anciens navigateurs de suporter la méthode "textContent"
if (Object.defineProperty &&
    Object.getOwnPropertyDescriptor &&
    Object.getOwnPropertyDescriptor(Element.prototype, "textContent") &&
    !Object.getOwnPropertyDescriptor(Element.prototype, "textContent").get) {
    (function() {
        var innerText = Object.getOwnPropertyDescriptor(Element.prototype, "innerText");
        Object.defineProperty(Element.prototype, "textContent", {
            get: function() {
                return innerText.get.call(this);
            },
            set: function(s) {
                return innerText.set.call(this, s);
            }
        });
    })();
}

function fermerJsError() {
    $("#javascriptErrors").fadeOut(250, function() {
        $("#javascriptErrorsList").html("");
    });
}

function openPopup(texte) {
    $.magnificPopup.open({
        items: {
            src: '<div class="white-popup">' + texte + '</div>',
            type: 'inline'
        }
    });
}

function linkToUrl(url) {
    window.open(url);
}

function viderListeConversions() {
    openPopup("<h2>Confirmation</h2><span class=\"icon icon-question\"></span> Êtes-vous sûr de vouloir vider la liste des conversions ?<div style=\"margin-top: 15px;\"><button id=\"viderListeConversionOK\" onclick=\"viderListeConversionsOK();\"><span class=\"icon icon-valider\"></span> Oui</button> <button class=\"closeMagnificPopup\"><span class=\"icon icon-close\"></span> Non</button></div>");
}

function viderListeConversionsOK() {
    $.magnificPopup.close();
    $("#resultsList").text("");
}
$(document).on('click', '.closeMagnificPopup', function(e) {
    $.magnificPopup.close();
});

function addslashes(string) {
    return string.replace(/\\/g, '\\\\').
    replace(/\u0008/g, '\\b').
    replace(/\t/g, '\\t').
    replace(/\n/g, '\\n').
    replace(/\f/g, '\\f').
    replace(/\r/g, '\\r').
    replace(/'/g, '\\\'').
    replace(/"/g, '\\"');
}
// émuler trim sur les anciens navigateurs
if (!String.prototype.trim) {
    String.prototype.trim = function() {
        return this.replace(/^[\s\uFEFF\xA0]+|[\s\uFEFF\xA0]+$/g, '');
    };
}
window.onerror = function(errorMsg, url, lineNumber, column, errorObj) {
    nbErrorJavascript++;
    var errorAlertText = '<h2>Informations de debug sur l\'erreur Javascript n°' + nbErrorJavascript + '</h2><ul><li>Code de l\'erreur : ' + errorMsg + '</li><li>Script : ' + url + '</li><li>Ligne : ' + lineNumber + '</li><li>Colonne : ' + column + '</li><li>StackTrace : ' + errorObj + '</li></ul><button class=\'closeMagnificPopup\'><span class=\'icon icon-close\'></span> Fermer la fenêtre</button>';
    var elError = document.createElement("li");
    var texteFormatted = addslashes(errorAlertText);
    elError.id = 'errorJavascriptNum' + nbErrorJavascript;
    elError.innerHTML = '<span class="icon icon-erreur"></span> Erreur Javascript détectée (n° de l\'erreur : ' + nbErrorJavascript + '). Pour plus d\'informations sur l\'erreur, <a href="#" onclick="openPopup(\'' + texteFormatted + '\');">cliquez ici</a> ou jetez un coup d\'oeil à la console Javascript. &nbsp;&nbsp;<span class="icon icon-close" style="color: black; cursor: pointer; font-size: 10pt;" title="Fermer" onclick="$(\'#errorJavascriptNum' + nbErrorJavascript + '\').fadeOut(250,function(){$(\'#errorJavascriptNum' + nbErrorJavascript + '\').html(\'\')});"></span>';
    document.getElementById("javascriptErrorsList").appendChild(elError);
    $("#javascriptErrors").fadeIn(250);
}
window.onbeforeunload = function() {
    return "Si vous fermez cette page, vous perdrez définitivement les conversions effectuées. Êtes-vous sûr de vouloir quitter cette page ?";
};
